#ifndef UTILS_H
#define UTILS_H
#include <VL53L1X.h>
#include <Adafruit_DRV2605.h>

#define STD_DEV 12.5
#define NUM_LASER 4
#define NUM_HAPTIC 4
#define NUM_DISCRETE_DRIVER_POWERS 5
#define DRIVER_BUZZ_START_IDX 47
#define HAPTIC_0_EN_PIN 4
#define HAPTIC_1_EN_PIN 6
#define HAPTIC_2_EN_PIN 10
#define HAPTIC_3_EN_PIN 12

#define Driver1EN 4
#define Driver2EN 6
#define Driver3EN 10
#define Driver4EN 12

#define Driver1PWM 3
#define Driver2PWM 5
#define Driver3PWM 9
#define Driver4PWM 11

typedef struct {
  int addr;
  VL53L1X dev;
} Laser;
typedef struct {
  int ENpin;  // Which pin the ENABLE is connected to
  Adafruit_DRV2605 drv;
} Driver;

void motor_intensity(int ld[], int yaw_rel, float *intensity, int minD);
int setDriverRealtimeValue( Driver drivers[NUM_HAPTIC], int driverIdx, unsigned char value );
extern const float laserOffsets[NUM_LASER];
extern const int hapticOffsets[NUM_HAPTIC];
void getReadings(float *roll, float *pitch, float *yaw, float ax, float ay, float az, float gx, float gy, float gz);
float convertRawAcceleration(int aRaw);
float convertRawGyro(int gRaw);

#endif // UTILS_H
